#include "nrf.h"

 uint8_t spi_send(uint8_t byte)
 {
	avr_spi_send;
 }
 
void nrf_init() 
{
	INITPORT;
	
    NRF_CE_LO;
    NRF_CSN_HI;

	#ifdef USE_INTERRUPT
	INIT_INTERRUPT
	#endif
    if ((int)*nrf_config.spi_init) nrf_config.spi_init();
}
extern void nrf_read_config()
{
	uint8_t temp;

	temp=NRF_Read_Cmd(EN_AA);
	nrf_config.NRF_Pipe_Auto_Ack_0=(temp&(1<<ENAA_P0))?1:0;
	nrf_config.NRF_Pipe_Auto_Ack_1=(temp&(1<<ENAA_P1))?1:0;
	nrf_config.NRF_Pipe_Auto_Ack_2=(temp&(1<<ENAA_P2))?1:0;
	nrf_config.NRF_Pipe_Auto_Ack_3=(temp&(1<<ENAA_P3))?1:0;
	nrf_config.NRF_Pipe_Auto_Ack_4=(temp&(1<<ENAA_P4))?1:0;
	nrf_config.NRF_Pipe_Auto_Ack_5=(temp&(1<<ENAA_P5))?1:0;
	temp=NRF_Read_Cmd(EN_RXADDR);
	nrf_config.NRF_Enable_Pipe_0=(temp&(1<<ERX_P0))?1:0;
	nrf_config.NRF_Enable_Pipe_1=(temp&(1<<ERX_P1))?1:0;
	nrf_config.NRF_Enable_Pipe_2=(temp&(1<<ERX_P2))?1:0;
	nrf_config.NRF_Enable_Pipe_3=(temp&(1<<ERX_P3))?1:0;
	nrf_config.NRF_Enable_Pipe_4=(temp&(1<<ERX_P4))?1:0;
	nrf_config.NRF_Enable_Pipe_5=(temp&(1<<ERX_P5))?1:0;
	nrf_config.NRF_Adres_Length=NRF_Read_Cmd(SETUP_AW)+2;
	temp=NRF_Read_Cmd(SETUP_RETR);
	nrf_config.NRF_Auto_Retransmit_Delay=temp>>4;
	nrf_config.NRF_Auto_Retransmit_Count=temp&0x0f;
	nrf_config.NRF_Channel=NRF_Read_Cmd(RF_CH);
	temp=NRF_Read_Cmd(RF_SETUP);
	nrf_config.NRF_TX_Power=(temp>>1)&0x03;
	nrf_config.NRF_Data_Rate=temp&0x20?0:temp&0x08?2:1;
	ReadReg(RX_ADDR_P0,nrf_config.NRF_RX_Adress_Pipe0,5);
	ReadReg(RX_ADDR_P1,nrf_config.NRF_RX_Adress_Pipe1,5);
	nrf_config.NRF_RX_Adress_Pipe2=NRF_Read_Cmd(RX_ADDR_P2);
	nrf_config.NRF_RX_Adress_Pipe3=NRF_Read_Cmd(RX_ADDR_P3);
	nrf_config.NRF_RX_Adress_Pipe4=NRF_Read_Cmd(RX_ADDR_P4);
	nrf_config.NRF_RX_Adress_Pipe5=NRF_Read_Cmd(RX_ADDR_P5);
	ReadReg(TX_ADDR,nrf_config.NRF_TX_Adress,5);
	nrf_config.NRF_Payload_Size_Pipe0=NRF_Read_Cmd(RX_PW_P0);
	nrf_config.NRF_Payload_Size_Pipe1=NRF_Read_Cmd(RX_PW_P1);
	nrf_config.NRF_Payload_Size_Pipe2=NRF_Read_Cmd(RX_PW_P2);
	nrf_config.NRF_Payload_Size_Pipe3=NRF_Read_Cmd(RX_PW_P3);
	nrf_config.NRF_Payload_Size_Pipe4=NRF_Read_Cmd(RX_PW_P4);
	nrf_config.NRF_Payload_Size_Pipe5=NRF_Read_Cmd(RX_PW_P5);
	nrf_config.NRF_En_No_Ack=NRF_Read_Cmd(FEATURE)&0x01;
	nrf_config.NRF_Status=NRF_Read_Cmd(STATUS);
	temp=NRF_Read_Cmd(CONFIG);
	nrf_config.NRF_CRC_Enable=(temp>>3)&0x01;
	nrf_config.NRF_CRC_Mode=(temp>>2)&0x01;
}
void nrf_configure() 
{
	NRF_POWERDOWN;
	NRF_Send_Cmd( EN_AA,  ((nrf_config.NRF_Pipe_Auto_Ack_0?1:0)<<ENAA_P0)|
								((nrf_config.NRF_Pipe_Auto_Ack_1?1:0)<<ENAA_P1)|
								((nrf_config.NRF_Pipe_Auto_Ack_2?1:0)<<ENAA_P2)|
								((nrf_config.NRF_Pipe_Auto_Ack_3?1:0)<<ENAA_P3)|
								((nrf_config.NRF_Pipe_Auto_Ack_4?1:0)<<ENAA_P4)|
								((nrf_config.NRF_Pipe_Auto_Ack_5?1:0)<<ENAA_P5));
	NRF_Send_Cmd( EN_RXADDR,	((nrf_config.NRF_Enable_Pipe_0?1:0)<<ERX_P0)|
									((nrf_config.NRF_Enable_Pipe_1?1:0)<<ERX_P1)|
									((nrf_config.NRF_Enable_Pipe_2?1:0)<<ERX_P2)|
									((nrf_config.NRF_Enable_Pipe_3?1:0)<<ERX_P3)|
									((nrf_config.NRF_Enable_Pipe_4?1:0)<<ERX_P4)|
									((nrf_config.NRF_Enable_Pipe_5?1:0)<<ERX_P5));
	NRF_Send_Cmd( SETUP_AW, nrf_config.NRF_Adres_Length-2);
	NRF_Send_Cmd( SETUP_RETR, ((nrf_config.NRF_Auto_Retransmit_Delay<<4)|nrf_config.NRF_Auto_Retransmit_Count));
	NRF_Send_Cmd( RF_CH,nrf_config.NRF_Channel);
	NRF_Send_Cmd( RF_SETUP,0x01|(nrf_config.NRF_TX_Power<<1)|(nrf_config.NRF_Data_Rate==0?0x04:((nrf_config.NRF_Data_Rate&0x02)?1:0))<<3);
	WriteReg(W_REGISTER|RX_ADDR_P0,nrf_config.NRF_RX_Adress_Pipe0,5);
	WriteReg(W_REGISTER|RX_ADDR_P1,nrf_config.NRF_RX_Adress_Pipe1,5);
	NRF_Send_Cmd( RX_ADDR_P2,nrf_config.NRF_RX_Adress_Pipe2);
	NRF_Send_Cmd( RX_ADDR_P3,nrf_config.NRF_RX_Adress_Pipe3);
	NRF_Send_Cmd( RX_ADDR_P4,nrf_config.NRF_RX_Adress_Pipe4);
	NRF_Send_Cmd( RX_ADDR_P5,nrf_config.NRF_RX_Adress_Pipe5);
	WriteReg(W_REGISTER|TX_ADDR,nrf_config.NRF_TX_Adress,5);
    NRF_Send_Cmd( RX_PW_P0, nrf_config.NRF_Payload_Size_Pipe0);
	NRF_Send_Cmd( RX_PW_P1, nrf_config.NRF_Payload_Size_Pipe1);
	NRF_Send_Cmd( RX_PW_P2, nrf_config.NRF_Payload_Size_Pipe2);
	NRF_Send_Cmd( RX_PW_P3, nrf_config.NRF_Payload_Size_Pipe3);
	NRF_Send_Cmd( RX_PW_P4, nrf_config.NRF_Payload_Size_Pipe4);
	NRF_Send_Cmd( RX_PW_P5, nrf_config.NRF_Payload_Size_Pipe5);
	NRF_Send_Cmd( DYNPD, 0);
    NRF_Send_Cmd( FEATURE, nrf_config.NRF_En_No_Ack?1:0);
	NRF_Send_Cmd( STATUS, (1<<RX_DR)|(1<<TX_DS)|(1<<MAX_RT));
#ifndef USE_INTERRUPT
	nrf_config.DS_Delay=nrf_config.NRF_Auto_Retransmit_Count*(nrf_config.NRF_Auto_Retransmit_Delay+3);
	if (!nrf_config.DS_Delay) nrf_config.DS_Delay=200;
#endif
	nrf_config.cur_status=NRF24L01_FREE;
    
	nrf_read_status(&nrf_config);
	if (nrf_config.NRF_Status&0x1)
	{
		NRF_CSN_LO;
		spi_send(FLUSH_TX);
		NRF_CSN_HI;
		nrf_read_status(&nrf_config);
	}
	while ((nrf_config.NRF_Status&0x0e)!=0x0e)
	{
		nrf_get_data(nrf_config.nrf_buf);	
		nrf_read_status();
	}
	if (nrf_config.NRF_Mode_RX) NRF_RX_POWERUP;

	NRF_CE_HI;


} 

uint8_t nrf_read_status()
{
	NRF_CSN_LO;
	nrf_config.NRF_Status=spi_send(NRF_NOP);
	NRF_CSN_HI;
	return (nrf_config.NRF_Status);
}

uint8_t nrf_read_retr_count()
{
	return (NRF_Read_Cmd(OBSERVE_TX)&0x0f);
}
extern uint8_t nrf_read_fifo_status()
{
	return (NRF_Read_Cmd(FIFO_STATUS));	
}

void NRF_Send_Cmd(uint8_t reg, uint8_t value)
{
	
	WriteReg(W_REGISTER | (REGISTER_MASK & reg),&value,1);
	
}

uint8_t NRF_Read_Cmd(uint8_t reg)
{
	uint8_t result;
	ReadReg((REGISTER_MASK & reg),&result,1);
	return (result);
}


extern NRF24L01_RET_STATUS nrf_send(uint8_t * value, uint8_t len,uint8_t noack) 
{
	uint8_t ret,cmd=W_TX_PAYLOAD;
	if (len>32) len=32;
	nrf_read_status();
	if (nrf_config.NRF_Status&(1<<TX_FULL)) return NRF24L01_TX_FULL;
		NRF_CE_LO;
		NRF_TX_POWERUP;
	if ((nrf_config.NRF_En_No_Ack)&&(noack)) cmd=W_TX_PAYLOAD_NOACK;
	WriteReg(cmd,value,len);
    NRF_CE_HI;
#ifndef USE_INTERRUPT
	_delay_us(5);
	uint32_t DS_Delay=nrf_config.DS_Delay*10;
#ifdef USE_IRQ_PIN
	do
	{
		_delay_us(25);
	}while((DS_Delay--) && (GET(IRQ)));	
	nrf_read_status();	
#else
	do{
		_delay_us(25);
		nrf_read_status();
	}while((DS_Delay--) && ((nrf_config.NRF_Status&((1<<TX_DS)|(1<<MAX_RT)))==0));
#endif
	if (DS_Delay==0)
	{
		ret=NRF24L01_CHIP_ERROR;
		nrf_config.cur_status|=NRF24L01_CHIP_ERR;
	}		
	else
	{
		if (noack)
		{
			if (nrf_config.NRF_Status&(1<<TX_DS))
			{
				ret=NRF24L01_DATA_SEND_NOACK_OK;
				nrf_config.cur_status|=NRF24L01_SEND_OK;
				nrf_config.send_ok_count++;
			}				
		}else
		{
			if (nrf_config.NRF_Status&(1<<TX_DS))
			{
				ret=NRF24L01_DATA_SEND_ACK_RECEIVED_OK;
				nrf_config.cur_status|=NRF24L01_SEND_OK;
				nrf_config.send_ok_count++;
			}				
			if (nrf_config.NRF_Status&(1<<MAX_RT))
			{
				NRF_CSN_LO;
				spi_send(FLUSH_TX);
				NRF_CSN_HI;
				ret=NRF24L01_DATA_SEND_NO_ACK_RECEIVED;
				nrf_config.cur_status|=NRF24L01_SEND_ERROR;
				nrf_config.send_nok_count++;
			}				
		}
		NRF_Send_Cmd(STATUS,(1<<TX_DS)|(1<<MAX_RT));
	}		
	if (nrf_read_fifo_status()&(1<<TX_EMPTY))
	{
		if (nrf_config.NRF_Mode_RX)
		{
			NRF_RX_POWERUP;
			NRF_CE_HI;
		}
		else
		{
			NRF_POWERDOWN;
			NRF_CE_LO;
		}
	}		
#else
	ret=NRF24L01_DATA_SEND_OK;
	nrf_config.cur_status|=NRF24L01_TRANSMIT_P;
#endif
return ret;
}

void WriteReg(uint8_t cmd, uint8_t *write, uint8_t size)
{
	uint8_t i;
	NRF_CSN_LO;
	spi_send(cmd);
	for (i=0;i<size;i++) spi_send(write[i]);
	NRF_CSN_HI;
}

uint8_t ReadReg(uint8_t reg, uint8_t *recv, uint8_t size)
{
	uint8_t temp,i;
	    NRF_CSN_LO;
	    temp=spi_send(reg);
	    for (i=0;i<size;i++) recv[i]=spi_send(recv[i]);
	    NRF_CSN_HI;
		return(temp);
}

extern uint8_t nrf_get_data(uint8_t *data)
{
	uint8_t payln;
	do
	{
		nrf_read_status();
		payln=(nrf_config.NRF_Status&0x0e)>>1;
		if (payln==0x07) return NRF24L01_NO_DATA_RECEIVED;
		uint8_t rx_pw = NRF_Read_Cmd(RX_PW_P0 + payln);
		nrf_config.NRF_Status=ReadReg(R_RX_PAYLOAD,data,rx_pw);
		nrf_config.recv_count++;
		NRF_Send_Cmd(STATUS,(1<<RX_DR));
	}
	while((nrf_read_fifo_status()&(1<<RX_EMPTY))==0);
	return (payln);
}

void nrf_check()
{
	#ifdef USE_INTERRUPT
	cli();
	#endif
	#ifdef USE_IRQ_PIN
	if (GET(IRQ))//&&((nrf_config.NRF_Status&0x7e)==0x0e))
	{
		#ifdef USE_INTERRUPT
		sei();
		#endif
		return;
	}
	#endif
	nrf_read_status();
	while ((nrf_config.NRF_Status&0x7e)!=0x0e)
	{
		if ((nrf_config.NRF_Status&(1<<RX_DR))||((nrf_config.NRF_Status&0x0e)!=0x0e))
		{
			nrf_get_data(nrf_config.nrf_buf);
			nrf_config.cur_status|=NRF24L01_RECV_PACKET;
		}
		if (nrf_config.NRF_Status&(1<<TX_DS))
		{
			NRF_Send_Cmd(STATUS,(1<<TX_DS));
			nrf_config.cur_status|=NRF24L01_SEND_OK;
			nrf_config.cur_status&=~NRF24L01_TRANSMIT_P;
			nrf_config.send_ok_count++;
		}
		if ((nrf_config.NRF_Status&(1<<MAX_RT))||(nrf_config.NRF_Status&0x01))
		{
			NRF_CSN_LO;
			spi_send(FLUSH_TX);
			NRF_CSN_HI;
			NRF_Send_Cmd(STATUS,(1<<MAX_RT));
			nrf_config.cur_status|=NRF24L01_SEND_ERROR;
			nrf_config.cur_status&=~NRF24L01_TRANSMIT_P;
			nrf_config.send_nok_count++;
		}
		nrf_read_status();
	}
	if (nrf_read_fifo_status()&(1<<TX_EMPTY))
	{
		if (nrf_config.NRF_Mode_RX)
		{
			NRF_RX_POWERUP;
			NRF_CE_HI;
		}
		else
		{
			NRF_POWERDOWN;
			NRF_CE_LO;
		}
	}
#ifdef USE_INTERRUPT
	sei();
#endif
}

#ifdef USE_IRQ_PIN
#ifdef USE_INTERRUPT
NRF_INTERRUPT
{
	if (GET(IRQ)) return;
	nrf_check();
}
#endif
#endif